# Go API client for openapi

**TMF API Reference : TMF 622 - Product Ordering Management**

**Release : 19.0 - June 2019**

The Product Ordering API provides a standardized mechanism for placing a product order with all of the necessary order parameters. The API consists of a simple set of operations that interact with CRM/Order Negotiation systems in a consistent manner. A product order is created based on a product offer that is defined in a catalog. The product offer identifies the product or set of products that are available to a customer, and includes characteristics such as pricing, product options and market. This API provide a task based resource to request order cancellation.

The product order references the product offer and identifies any specific requests made by the customer.

**Product Order resource**
A Product Order is a type of order which can be used to place an order between a customer and a service provider or between a service provider and a partner and vice versa. Main Product Order attributes are its identifier, state, priority category (mass market, Enterprise, etc.) related dates (start, completion, etc.), related billing account, related parties and order items. Main Order Items (aka order lines) attributes are the ordered offering and product characteristics with the related action to be performed (e.g. add or delete the products), state, location information for delivery, order item price and price alteration.

Product Order API performs the following operations on product order :

   -Retrieval of a product order or a collection of product orders depending on filter criteria
    -Partial update of a product order (including updating rules)
   -Creation of a product order (including default values and creation rules)
   -Deletion of product order (for administration purposes)
    -Notification of events on product order.

**cancelProductOrder resource**
This resource is used to request a product order cancellation.
Product Order API performs the following operations on product order :

   -Retrieval of a cancel product order or a collection of cancel product orders 
   -Creation of a cancel product order 
   -Notification of events on cancel product order.


Copyright © TM Forum 2019. All Rights Reserved




## Overview
This API client was generated by the [OpenAPI Generator](https://openapi-generator.tech) project.  By using the [OpenAPI-spec](https://www.openapis.org/) from a remote server, you can easily generate an API client.

- API version: 4.0.0
- Package version: 1.0.0
- Build package: org.openapitools.codegen.languages.GoClientCodegen

## Installation

Install the following dependencies:

```shell
go get github.com/stretchr/testify/assert
go get golang.org/x/oauth2
go get golang.org/x/net/context
```

Put the package under your project folder and add the following in import:

```golang
import sw "./openapi"
```

To use a proxy, set the environment variable `HTTP_PROXY`:

```golang
os.Setenv("HTTP_PROXY", "http://proxy_name:proxy_port")
```

## Configuration of Server URL

Default configuration comes with `Servers` field that contains server objects as defined in the OpenAPI specification.

### Select Server Configuration

For using other server than the one defined on index 0 set context value `sw.ContextServerIndex` of type `int`.

```golang
ctx := context.WithValue(context.Background(), sw.ContextServerIndex, 1)
```

### Templated Server URL

Templated server URL is formatted using default variables from configuration or from context value `sw.ContextServerVariables` of type `map[string]string`.

```golang
ctx := context.WithValue(context.Background(), sw.ContextServerVariables, map[string]string{
	"basePath": "v2",
})
```

Note, enum values are always validated and all unused variables are silently ignored.

### URLs Configuration per Operation

Each operation can use different server URL defined using `OperationServers` map in the `Configuration`.
An operation is uniquely identifield by `"{classname}Service.{nickname}"` string.
Similar rules for overriding default operation server index and variables applies by using `sw.ContextOperationServerIndices` and `sw.ContextOperationServerVariables` context maps.

```
ctx := context.WithValue(context.Background(), sw.ContextOperationServerIndices, map[string]int{
	"{classname}Service.{nickname}": 2,
})
ctx = context.WithValue(context.Background(), sw.ContextOperationServerVariables, map[string]map[string]string{
	"{classname}Service.{nickname}": {
		"port": "8443",
	},
})
```

## Documentation for API Endpoints

All URIs are relative to *https://serverRoot/tmf-api/productOrderingManagement/v4*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*CancelProductOrderApi* | [**CreateCancelProductOrder**](docs/CancelProductOrderApi.md#createcancelproductorder) | **Post** /cancelProductOrder | Creates a CancelProductOrder
*CancelProductOrderApi* | [**ListCancelProductOrder**](docs/CancelProductOrderApi.md#listcancelproductorder) | **Get** /cancelProductOrder | List or find CancelProductOrder objects
*CancelProductOrderApi* | [**RetrieveCancelProductOrder**](docs/CancelProductOrderApi.md#retrievecancelproductorder) | **Get** /cancelProductOrder/{id} | Retrieves a CancelProductOrder by ID
*EventsSubscriptionApi* | [**RegisterListener**](docs/EventsSubscriptionApi.md#registerlistener) | **Post** /hub | Register a listener
*EventsSubscriptionApi* | [**UnregisterListener**](docs/EventsSubscriptionApi.md#unregisterlistener) | **Delete** /hub/{id} | Unregister a listener
*NotificationListenersClientSideApi* | [**ListenToCancelProductOrderCreateEvent**](docs/NotificationListenersClientSideApi.md#listentocancelproductordercreateevent) | **Post** /listener/cancelProductOrderCreateEvent | Client listener for entity CancelProductOrderCreateEvent
*NotificationListenersClientSideApi* | [**ListenToCancelProductOrderInformationRequiredEvent**](docs/NotificationListenersClientSideApi.md#listentocancelproductorderinformationrequiredevent) | **Post** /listener/cancelProductOrderInformationRequiredEvent | Client listener for entity CancelProductOrderInformationRequiredEvent
*NotificationListenersClientSideApi* | [**ListenToCancelProductOrderStateChangeEvent**](docs/NotificationListenersClientSideApi.md#listentocancelproductorderstatechangeevent) | **Post** /listener/cancelProductOrderStateChangeEvent | Client listener for entity CancelProductOrderStateChangeEvent
*NotificationListenersClientSideApi* | [**ListenToProductOrderAttributeValueChangeEvent**](docs/NotificationListenersClientSideApi.md#listentoproductorderattributevaluechangeevent) | **Post** /listener/productOrderAttributeValueChangeEvent | Client listener for entity ProductOrderAttributeValueChangeEvent
*NotificationListenersClientSideApi* | [**ListenToProductOrderCreateEvent**](docs/NotificationListenersClientSideApi.md#listentoproductordercreateevent) | **Post** /listener/productOrderCreateEvent | Client listener for entity ProductOrderCreateEvent
*NotificationListenersClientSideApi* | [**ListenToProductOrderDeleteEvent**](docs/NotificationListenersClientSideApi.md#listentoproductorderdeleteevent) | **Post** /listener/productOrderDeleteEvent | Client listener for entity ProductOrderDeleteEvent
*NotificationListenersClientSideApi* | [**ListenToProductOrderInformationRequiredEvent**](docs/NotificationListenersClientSideApi.md#listentoproductorderinformationrequiredevent) | **Post** /listener/productOrderInformationRequiredEvent | Client listener for entity ProductOrderInformationRequiredEvent
*NotificationListenersClientSideApi* | [**ListenToProductOrderStateChangeEvent**](docs/NotificationListenersClientSideApi.md#listentoproductorderstatechangeevent) | **Post** /listener/productOrderStateChangeEvent | Client listener for entity ProductOrderStateChangeEvent
*ProductOrderApi* | [**CreateProductOrder**](docs/ProductOrderApi.md#createproductorder) | **Post** /productOrder | Creates a ProductOrder
*ProductOrderApi* | [**DeleteProductOrder**](docs/ProductOrderApi.md#deleteproductorder) | **Delete** /productOrder/{id} | Deletes a ProductOrder
*ProductOrderApi* | [**ListProductOrder**](docs/ProductOrderApi.md#listproductorder) | **Get** /productOrder | List or find ProductOrder objects
*ProductOrderApi* | [**PatchProductOrder**](docs/ProductOrderApi.md#patchproductorder) | **Patch** /productOrder/{id} | Updates partially a ProductOrder
*ProductOrderApi* | [**RetrieveProductOrder**](docs/ProductOrderApi.md#retrieveproductorder) | **Get** /productOrder/{id} | Retrieves a ProductOrder by ID


## Documentation For Models

 - [AgreementItemRef](docs/AgreementItemRef.md)
 - [AgreementRef](docs/AgreementRef.md)
 - [AppointmentRef](docs/AppointmentRef.md)
 - [BillingAccountRef](docs/BillingAccountRef.md)
 - [CancelOrder](docs/CancelOrder.md)
 - [CancelProductOrder](docs/CancelProductOrder.md)
 - [CancelProductOrderCreate](docs/CancelProductOrderCreate.md)
 - [CancelProductOrderCreateEvent](docs/CancelProductOrderCreateEvent.md)
 - [CancelProductOrderCreateEventPayload](docs/CancelProductOrderCreateEventPayload.md)
 - [CancelProductOrderInformationRequiredEvent](docs/CancelProductOrderInformationRequiredEvent.md)
 - [CancelProductOrderInformationRequiredEventPayload](docs/CancelProductOrderInformationRequiredEventPayload.md)
 - [CancelProductOrderStateChangeEvent](docs/CancelProductOrderStateChangeEvent.md)
 - [CancelProductOrderStateChangeEventPayload](docs/CancelProductOrderStateChangeEventPayload.md)
 - [Characteristic](docs/Characteristic.md)
 - [EntityRef](docs/EntityRef.md)
 - [Error](docs/Error.md)
 - [EventSubscription](docs/EventSubscription.md)
 - [EventSubscriptionInput](docs/EventSubscriptionInput.md)
 - [Money](docs/Money.md)
 - [Note](docs/Note.md)
 - [OrderItemActionType](docs/OrderItemActionType.md)
 - [OrderItemRelationship](docs/OrderItemRelationship.md)
 - [OrderPrice](docs/OrderPrice.md)
 - [OrderTerm](docs/OrderTerm.md)
 - [PaymentRef](docs/PaymentRef.md)
 - [Place](docs/Place.md)
 - [PlaceRef](docs/PlaceRef.md)
 - [Price](docs/Price.md)
 - [PriceAlteration](docs/PriceAlteration.md)
 - [Product](docs/Product.md)
 - [ProductOfferingPriceRef](docs/ProductOfferingPriceRef.md)
 - [ProductOfferingQualificationItemRef](docs/ProductOfferingQualificationItemRef.md)
 - [ProductOfferingQualificationRef](docs/ProductOfferingQualificationRef.md)
 - [ProductOfferingRef](docs/ProductOfferingRef.md)
 - [ProductOrder](docs/ProductOrder.md)
 - [ProductOrderAttributeValueChangeEvent](docs/ProductOrderAttributeValueChangeEvent.md)
 - [ProductOrderAttributeValueChangeEventPayload](docs/ProductOrderAttributeValueChangeEventPayload.md)
 - [ProductOrderCreate](docs/ProductOrderCreate.md)
 - [ProductOrderCreateEvent](docs/ProductOrderCreateEvent.md)
 - [ProductOrderCreateEventPayload](docs/ProductOrderCreateEventPayload.md)
 - [ProductOrderDeleteEvent](docs/ProductOrderDeleteEvent.md)
 - [ProductOrderDeleteEventPayload](docs/ProductOrderDeleteEventPayload.md)
 - [ProductOrderInformationRequiredEvent](docs/ProductOrderInformationRequiredEvent.md)
 - [ProductOrderInformationRequiredEventPayload](docs/ProductOrderInformationRequiredEventPayload.md)
 - [ProductOrderItem](docs/ProductOrderItem.md)
 - [ProductOrderItemStateType](docs/ProductOrderItemStateType.md)
 - [ProductOrderRef](docs/ProductOrderRef.md)
 - [ProductOrderStateChangeEvent](docs/ProductOrderStateChangeEvent.md)
 - [ProductOrderStateChangeEventPayload](docs/ProductOrderStateChangeEventPayload.md)
 - [ProductOrderStateType](docs/ProductOrderStateType.md)
 - [ProductOrderUpdate](docs/ProductOrderUpdate.md)
 - [ProductPrice](docs/ProductPrice.md)
 - [ProductRef](docs/ProductRef.md)
 - [ProductRefOrValue](docs/ProductRefOrValue.md)
 - [ProductRelationship](docs/ProductRelationship.md)
 - [ProductSpecificationRef](docs/ProductSpecificationRef.md)
 - [ProductStatusType](docs/ProductStatusType.md)
 - [ProductTerm](docs/ProductTerm.md)
 - [Quantity](docs/Quantity.md)
 - [QuoteItemRef](docs/QuoteItemRef.md)
 - [QuoteRef](docs/QuoteRef.md)
 - [RelatedChannel](docs/RelatedChannel.md)
 - [RelatedParty](docs/RelatedParty.md)
 - [RelatedPlaceRefOrValue](docs/RelatedPlaceRefOrValue.md)
 - [RelatedProductOrderItem](docs/RelatedProductOrderItem.md)
 - [ResourceRef](docs/ResourceRef.md)
 - [ServiceRef](docs/ServiceRef.md)
 - [TargetProductSchema](docs/TargetProductSchema.md)
 - [TaskStateType](docs/TaskStateType.md)
 - [TimePeriod](docs/TimePeriod.md)


## Documentation For Authorization

 Endpoints do not require authorization.


## Documentation for Utility Methods

Due to the fact that model structure members are all pointers, this package contains
a number of utility functions to easily obtain pointers to values of basic types.
Each of these functions takes a value of the given basic type and returns a pointer to it:

* `PtrBool`
* `PtrInt`
* `PtrInt32`
* `PtrInt64`
* `PtrFloat`
* `PtrFloat32`
* `PtrFloat64`
* `PtrString`
* `PtrTime`

## Author



